import opt_einsum as oe
import pickle
import numpy as np

if __name__ == "__main__":

    with open(
        "./instances/qc_circuit_n49_m14_s9_e6_pEFGH_simplified.pkl", "rb"
    ) as file:
        format_string, tensors, path_meta, sum_output = pickle.load(file)

    # path optimized for minimal intermediate size
    path, size_log2, flops_log10, min_density, avg_density = path_meta[0]
    print("Size optimized path")
    print("log10[FLOPS]:", round(flops_log10, 2))
    print("log2[SIZE]:", round(size_log2, 2))
    result = oe.contract(format_string, *tensors, optimize=path)
    print("sum[OUTPUT]:", np.sum(result), sum_output)

    # path optimized for minimal total flops is stored und the key 1
    print("Flops optimized path")
    print("log10[FLOPS]:", round(flops_log10, 2))
    print("log2[SIZE]:", round(size_log2, 2))
    path, size_log2, flops_log10, min_density, avg_density = path_meta[1]
    result = oe.contract(format_string, *tensors, optimize=path)
    print("sum[OUTPUT]:", np.sum(result), sum_output)
